#include <PWM.h>//library for high PWM frequency whatever only on pin 9
//#include <PinChangeInt.h>//for ZCD change pin interrupt on pin 15, 16, 17
#include <SM.h>

SM Machine(STATE0);//create simple statemachine



#define FASTADC 1
// defines for setting and clearing register bits
#ifndef cbi
#define cbi(sfr, bit) (_SFR_BYTE(sfr) &= ~_BV(bit))
#endif
#ifndef sbi
#define sbi(sfr, bit) (_SFR_BYTE(sfr) |= _BV(bit))
#endif

int transSUP100;  //transition de SUPERIEURE à 100
int transINF100;   //transition de INFERIEURE à 100
int etat=0;


//use pin 11 on the Mega instead, otherwise there is a frequency cap at 31 Hz
int led = 9;                // the pin that the LED is attached to
int brightness = 126;         // how bright the LED is
int fadeAmount = 5;         // how many points to fade the LED by
int32_t frequency =712000; //frequency (in Hz)712000 for L=100uH and C=0.5nF

// define some values used by the panel and buttons

int reading;
double memo2;
double frequence=0;
void setup()
{
  Serial.begin(115200);
  //initialize all timers except for 0, to save time keeping functions
  InitTimersSafe(); 
  bool success = SetPinFrequencySafe(led, frequency);
  pinMode(13, OUTPUT);
  pinMode(7, OUTPUT);
  //Change acquisition time for ADC
#if FASTADC// ex: 16Mhz/128= 125KHZ, 13 adc clocks needed, adc Prescale settings
  //125/13=9600Hz à la base soit 105 µs
  //pour 16: 16000000/(16*13)=76923hz 13µS
  //pour 32: 16000000/(32*13)=38461hz 26µs
  //pour 64: 16000000/(64*13)=19230hz 52µs
  //pour 128 104µs
  //sbi pour 1
  //cbi pour 0
  // set prescale to     16   8    4   2    128    64    32
  cbi(ADCSRA,ADPS2) ; // 1    0    0   0     1      1    1
  sbi(ADCSRA,ADPS1) ; // 0    1    1   0     1      1    0
  cbi(ADCSRA,ADPS0) ; // 0    1    0   1     1      0    1
#endif//here I use a prescale of 16
  pwmWrite(led, brightness);// generate PWM on pin 9 for LC circuit tuning
  //analogWrite(13,240);
  digitalWrite(13,HIGH);
  analogWrite(6,0);

}

void loop()
{
  //reading = analogRead(0)-900;
  EXEC(Machine);//run statemachine
  reading = analogRead(0)-900;
  //Serial.println(reading);
  if (reading>79) {
    transSUP100=1;
  }
  else transSUP100=0;

  if (reading<79) {
    transINF100=1;
  }
  else transINF100=0;
}

State STATE0(){
  //Serial.println("ETAPE 0");
  frequence=0;
  analogWrite(6,(255*frequence)/75.15);
  if(transSUP100==1) Machine.Set(STATE1);//
}


State STATE1(){
  //Serial.println("ETAPE 1");
  if(RE(transINF100==1,etat)==1) Machine.Set(STATE2);//
  if(Machine.Timeout(1000)) Machine.Set(STATE0);//
}

State STATE2(){
  //Serial.println("ETAPE 2");
  if(RE(transSUP100==1,etat)==1)  {
    memo2=micros();
    Machine.Set(STATE3);
  }
  if(Machine.Timeout(1000)) Machine.Set(STATE0);//
}

State STATE3(){
  //Serial.println("ETAPE 3");
  if(RE(transINF100==1,etat)==1) Machine.Set(STATE4);//
  if(Machine.Timeout(1000)) Machine.Set(STATE0);//
}


State STATE4(){
  // Serial.println("ETAPE 4");
  if(RE(transSUP100==1,etat)==1)
  {
    frequence=1000000/(micros()-memo2);
    Serial.println(frequence);
    analogWrite(6,(255*frequence)/75.15);
    Machine.Set(STATE1);
  }//0
  if(Machine.Timeout(1000)) Machine.Set(STATE0);//
}

